unit usb;

// benutzt Informationen von
// http://www.sixca.com/delphi/article/microchip_usb.html

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, usbdll, ComCtrls, ExtCtrls, CPort;

const
  //konstanten fr 28pin board
  LED_ONOFF       = $31;
  READ_SWITCH     = $32;
  RD_POT          = $37;
  RD_ADC          = $37;
  SET_AN	  = $38;
  SET_PWM         = $39;
  SET_SOC         = $3A;
  SET_SIGNAL      = $3B;
  SET_DIR         = $3C;
  READ_DATA       = $3D;
  ICSP_WRITE      = $3E;
  ICSP_READ       = $3F;


  SET_KERN        = $40;
  SET_PICTYPE	  = $41;
  SET_ADRESS	  = $42;

  SYS_IO	  = $50;
  SYS_ADC     	  = $51;
  SYS_FRQ     	  = $52;
  SYS_SPI         = $53;
  SYS_I2C	  = $54;
  SYS_LCD1	  = $55;
  SYS_LCD2	  = $56;
  SYS_PWM1	  = $57;
  SYS_PWM2	  = $58;
  SYS_RS232	  = $59;
  SYS_EEPROM	  = $5A;
  SYS_KEY	  = $5B;
  SYS_STEP4	  = $5C;
  SYS_STEP1 	  = $5D;
  SYS_STEP2	  = $5E;
  SYS_STEP3	  = $5F;
  SYS_L297_1	  = $60;
  SYS_L297_2	  = $61;
  SYS_L297_3	  = $62;
  SYS_L297_4	  = $63;
  SYS_ServoB	  = $64;
  SYS_ServoC	  = $65;
  SYS_SR	  = $66;
  SYS_MWIRE	  = $67;
  SYS_COUNTER_0	  = $68;
  SYS_COUNTER_3	  = $69;

  SYS_TMR	  = $6A;
  SYS_LED	  = $6B;



type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button5: TButton;
    Button10: TButton;
    Button4: TButton;
    fakeTbCheckBox: TCheckBox;
    fakeBLCheckBox: TCheckBox;
    Button8: TButton;
    fakeSprutCheckBox: TCheckBox;
    ComPort1: TComPort;
    vers_RadioGroup: TRadioGroup;
    Button75: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button9: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    TabSheet2: TTabSheet;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    TabSheet3: TTabSheet;
    Button36: TButton;
    Button37: TButton;
    Button38: TButton;
    Button39: TButton;
    TabSheet4: TTabSheet;
    Button40: TButton;
    Button41: TButton;
    Button42: TButton;
    Button43: TButton;
    Button11: TButton;
    Button7: TButton;
    Button6: TButton;
    Button3: TButton;
    TabSheet5: TTabSheet;
    Button69: TButton;
    Button70: TButton;
    TabSheet6: TTabSheet;
    Button31: TButton;
    Button32: TButton;
    Button33: TButton;
    Button34: TButton;
    Button35: TButton;
    Button44: TButton;
    Button45: TButton;
    Button68: TButton;
    TabSheet7: TTabSheet;
    Button12: TButton;
    Button46: TButton;
    Button47: TButton;
    Button48: TButton;
    Button49: TButton;
    Button50: TButton;
    Button51: TButton;
    Button52: TButton;
    Button53: TButton;
    Button54: TButton;
    Button55: TButton;
    Button56: TButton;
    Button57: TButton;
    Button67: TButton;
    Button66: TButton;
    Button65: TButton;
    Button64: TButton;
    Button63: TButton;
    Button62: TButton;
    Button61: TButton;
    TabSheet8: TTabSheet;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    TabSheet9: TTabSheet;
    Button27: TButton;
    Button28: TButton;
    Button29: TButton;
    Button30: TButton;
    Button58: TButton;
    Button59: TButton;
    Button60: TButton;
    TabSheet10: TTabSheet;
    GroupBox1: TGroupBox;
    SB0TrackBar: TTrackBar;
    SB0CheckBox: TCheckBox;
    SB1CheckBox: TCheckBox;
    SB1TrackBar: TTrackBar;
    SB2CheckBox: TCheckBox;
    SB2TrackBar: TTrackBar;
    Button71: TButton;
    Button72: TButton;
    GroupBox2: TGroupBox;
    SC0TrackBar: TTrackBar;
    SC0CheckBox: TCheckBox;
    SC1CheckBox: TCheckBox;
    SC1TrackBar: TTrackBar;
    SC2CheckBox: TCheckBox;
    SC2TrackBar: TTrackBar;
    Button73: TButton;
    Button74: TButton;
    TabSheet11: TTabSheet;
    GroupBox3: TGroupBox;
    Button76: TButton;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    SB3TrackBar: TTrackBar;
    SB4TrackBar: TTrackBar;
    SB5TrackBar: TTrackBar;
    SB6TrackBar: TTrackBar;
    SB3CheckBox: TCheckBox;
    SB4CheckBox: TCheckBox;
    SB5CheckBox: TCheckBox;
    SB6CheckBox: TCheckBox;
    SB7CheckBox: TCheckBox;
    SB7TrackBar: TTrackBar;
    SC6TrackBar: TTrackBar;
    SC7TrackBar: TTrackBar;
    SC6CheckBox: TCheckBox;
    SC7CheckBox: TCheckBox;
    SrModeRadioGroup: TRadioGroup;
    SrClkRadioGroup: TRadioGroup;
    Button77: TButton;
    GroupBox4: TGroupBox;
    SRTrackBar: TTrackBar;
    Button78: TButton;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    TabSheet12: TTabSheet;
    Button79: TButton;
    Label28: TLabel;
    Button80: TButton;
    Button81: TButton;
    Label29: TLabel;
    TabSheet13: TTabSheet;
    Label32: TLabel;
    GroupBox5: TGroupBox;
    Button82: TButton;
    SpiSampleRadioGroup: TRadioGroup;
    SpiClkRadioGroup: TRadioGroup;
    SpiSlavesRadioGroup: TRadioGroup;
    SpiModeRadioGroup: TRadioGroup;
    Button83: TButton;
    Button84: TButton;
    Button85: TButton;
    SpiCsRadioGroup: TRadioGroup;
    GroupBox6: TGroupBox;
    Button86: TButton;
    MwClkRadioGroup: TRadioGroup;
    Button87: TButton;
    Button88: TButton;
    Button89: TButton;
    Step1CheckBox: TCheckBox;
    pwmComboBox: TComboBox;
    Label30: TLabel;
    Button90: TButton;
    spiCSCheckBox: TCheckBox;
    csaktivCheckBox: TCheckBox;
    TabSheet14: TTabSheet;
    Button91: TButton;
    Button92: TButton;
    Button93: TButton;
    Button94: TButton;
    abcCheckBox: TCheckBox;
    abcModeRadioGroup: TRadioGroup;
    abcrichtRadioGroup: TRadioGroup;
    abcTrackBar: TTrackBar;
    Button95: TButton;
    Button96: TButton;
    abcTaktRadioGroup: TRadioGroup;
    abcLabel: TLabel;
    abcasyncCheckBox: TCheckBox;
    Button97: TButton;
    Button98: TButton;
    abcBbCheckBox: TCheckBox;
    Button99: TButton;
    Button100: TButton;
    Button101: TButton;
    Button102: TButton;
    Button103: TButton;
    Button104: TButton;
    Button105: TButton;
    Button106: TButton;
    Button107: TButton;
    abcX10CheckBox: TCheckBox;
    Button108: TButton;
    Counter: TTabSheet;
    Button109: TButton;
    Button110: TButton;
    Button111: TButton;
    Button112: TButton;
    Button113: TButton;
    Label31: TLabel;
    Label33: TLabel;
    Button114: TButton;
    Button115: TButton;
    Button116: TButton;
    Button117: TButton;
    Button118: TButton;
    Button119: TButton;
    Button120: TButton;
    Button121: TButton;
    Button122: TButton;
    Button123: TButton;
    Button124: TButton;
    Button125: TButton;
    Button126: TButton;
    Button127: TButton;
    Button128: TButton;
    Label34: TLabel;
    CheckBox1: TCheckBox;
    ADCRadioGroup: TRadioGroup;
    Button129: TButton;
    Button130: TButton;
    Label35: TLabel;
    Label36: TLabel;
    Button131: TButton;
    Label37: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Sende_Empfange(N,M :byte);
    procedure Button10Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    function USBinfo:boolean;
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button79Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
    procedure Button26Click(Sender: TObject);
    procedure Button29Click(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure Button28Click(Sender: TObject);
    procedure Button30Click(Sender: TObject);
    procedure Button31Click(Sender: TObject);
    procedure Button32Click(Sender: TObject);
    procedure Button33Click(Sender: TObject);
    procedure Button34Click(Sender: TObject);
    procedure Button35Click(Sender: TObject);
    procedure Button36Click(Sender: TObject);
    procedure Button80Click(Sender: TObject);
    procedure Button37Click(Sender: TObject);
    procedure Button38Click(Sender: TObject);
    procedure Button81Click(Sender: TObject);
    procedure Button39Click(Sender: TObject);
    procedure Button40Click(Sender: TObject);
    procedure Button41Click(Sender: TObject);
    procedure Button42Click(Sender: TObject);
    procedure Button43Click(Sender: TObject);
    procedure Button44Click(Sender: TObject);
    procedure Button45Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button46Click(Sender: TObject);
    procedure Button47Click(Sender: TObject);
    procedure Button48Click(Sender: TObject);
    procedure Button49Click(Sender: TObject);
    procedure Button50Click(Sender: TObject);
    procedure Button51Click(Sender: TObject);
    procedure Button52Click(Sender: TObject);
    procedure Button53Click(Sender: TObject);
    procedure Button54Click(Sender: TObject);
    procedure Button55Click(Sender: TObject);
    procedure Button56Click(Sender: TObject);
    procedure Button57Click(Sender: TObject);
    procedure Button58Click(Sender: TObject);
    procedure Button59Click(Sender: TObject);
    procedure Button60Click(Sender: TObject);
    procedure Button61Click(Sender: TObject);
    procedure Button62Click(Sender: TObject);
    procedure Button63Click(Sender: TObject);
    procedure Button64Click(Sender: TObject);
    procedure Button65Click(Sender: TObject);
    procedure Button66Click(Sender: TObject);
    procedure Button67Click(Sender: TObject);
    procedure Button68Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AsciiCheckBoxClick(Sender: TObject);
    procedure vers_RadioGroupClick(Sender: TObject);
    procedure Button69Click(Sender: TObject);
    procedure Button70Click(Sender: TObject);
    procedure Button72Click(Sender: TObject);
    procedure Button74Click(Sender: TObject);
    procedure Button71Click(Sender: TObject);
    procedure Button73Click(Sender: TObject);
    procedure SB0TrackBarChange(Sender: TObject);
    procedure SC0TrackBarChange(Sender: TObject);
    procedure Button75Click(Sender: TObject);
    procedure Button76Click(Sender: TObject);
    procedure Button77Click(Sender: TObject);
    procedure Button78Click(Sender: TObject);
    procedure SRTrackBarChange(Sender: TObject);
    procedure Button82Click(Sender: TObject);
    procedure Button83Click(Sender: TObject);
    procedure Button84Click(Sender: TObject);
    procedure Button85Click(Sender: TObject);
    procedure SB0CheckBoxClick(Sender: TObject);
    procedure Button86Click(Sender: TObject);
    procedure Button87Click(Sender: TObject);
    procedure Button88Click(Sender: TObject);
    procedure Button89Click(Sender: TObject);
    procedure Button90Click(Sender: TObject);
    procedure Button95Click(Sender: TObject);
    procedure runsteps(kanal: integer);
    procedure abcTrackBarChange(Sender: TObject);
    procedure Button96Click(Sender: TObject);
    procedure Button98Click(Sender: TObject);
    procedure Button99Click(Sender: TObject);
    procedure Button100Click(Sender: TObject);
    procedure Button101Click(Sender: TObject);
    procedure Button102Click(Sender: TObject);
    procedure Button103Click(Sender: TObject);
    procedure Button104Click(Sender: TObject);
    procedure Button105Click(Sender: TObject);
    procedure Button106Click(Sender: TObject);
    procedure Button107Click(Sender: TObject);
    procedure Button108Click(Sender: TObject);
    procedure Button109Click(Sender: TObject);
    procedure Button110Click(Sender: TObject);
    procedure Button111Click(Sender: TObject);
    procedure Button112Click(Sender: TObject);
    procedure Button113Click(Sender: TObject);
    procedure Button114Click(Sender: TObject);
    procedure Button115Click(Sender: TObject);
    procedure Button116Click(Sender: TObject);
    procedure Button117Click(Sender: TObject);
    procedure Button118Click(Sender: TObject);
    procedure Button119Click(Sender: TObject);
    procedure Button120Click(Sender: TObject);
    procedure Button121Click(Sender: TObject);
    procedure Button122Click(Sender: TObject);
    procedure Button123Click(Sender: TObject);
    procedure Button124Click(Sender: TObject);
    procedure Button125Click(Sender: TObject);
    procedure Button126Click(Sender: TObject);
    procedure Button128Click(Sender: TObject);
    procedure Button127Click(Sender: TObject);
    procedure Button129Click(Sender: TObject);
    procedure Button130Click(Sender: TObject);
    procedure Button131Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    rs4all : boolean;
  end;


var
  Form1: TForm1;

  BootloaderDa   : boolean = false;
  Tbda           : boolean = false;
  SprutDa        : boolean = false;
  Firmware       : integer;
  rxstr          : string;
  pwmmax         : integer = 255;
  abcschritte    : integer = 1;


implementation

{$R *.DFM}


// Die DLL-Version abfragen
procedure TForm1.Button1Click(Sender: TObject);
begin
  memo1.Lines.add('_MPUSBGetDLLVersion : '+inttohex(_MPUSBGetDLLVersion,8));
end;


//wieviele Testplatinen sind angeschlossen?
// bei mehr als einer bekomme ich ein Problem, da ich immer die erste anspreche
procedure TForm1.Button2Click(Sender: TObject);
begin
  memo1.Lines.add('_MPUSBGetDeviceCount : '+inttohex(_MPUSBGetDeviceCount(vid_pid),8));
end;


//RESET fr USB-Device
procedure TForm1.Button5Click(Sender: TObject);
begin
  send_buf[0]:= RESET;  //bRESET_DEVICE;
  Sende_Empfange(1,0);
  memo1.lines.add('');
  Memo1.lines.add(' ');
  Memo1.lines.add('finished');

  if vers_RadioGroup.itemindex>0 then begin
    if ComPort1.Connected then ComPort1.close;
  end;
end;  //RESET fr USB-Device




//N Bytes senden und M Bytes empfangen
//timeout ist jeweils 100 ms
procedure TForm1.Sende_Empfange(N,M :byte);
var
   selection   : DWORD;
   RecvLength  : DWORD;
   fehler      : integer;
   cdcstr      : string[16];
   asciistr    : string[63];
   outstr      : string;
   k           : integer;
   nrrx        : integer;

// wandeln eines ASCII-Zeichens in einen Zahlenwert
function asciiwert(ch:char):integer;
begin
  result:=0;
  case ch of
  '1': result:=1;
  '2': result:=2;
  '3': result:=3;
  '4': result:=4;
  '5': result:=5;
  '6': result:=6;
  '7': result:=7;
  '8': result:=8;
  '9': result:=9;
  'A': result:=10;
  'B': result:=11;
  'C': result:=12;
  'D': result:=13;
  'E': result:=14;
  'F': result:=15;
  end;
end;

begin
//  memo1.lines.add('');
  // je nach USB4all-Version mssen noch die Strings gewandelt werden (hex-ASCII, ASCII-hex)
  case vers_RadioGroup.Itemindex of
    2:begin                     //      USB4all-CCDhex
      //senden ber comport
      if not ComPort1.Connected then Comport1.open;
      ComPort1.ClearBuffer(true, true);
      cdcstr :='';
      for k:=0 to 15 do cdcstr := cdcstr + chr(send_buf[k]);
      memo1.lines.add('CDC_tx: '+ inttostr(Comport1.WriteStr(cdcstr)));

      //empfangen ber comport
      //ReadStr(var Str: String; Count: Integer): Integer;
      nrrx:=Comport1.ReadStr(rxstr, 16);
      memo1.lines.add('CDC_rx: '+ inttostr(nrrx));
      outstr:='';
      for k:=1 to (nrrx) do outstr:=outstr+inttohex(ord(rxstr[k]),2)+'-';
      memo1.lines.add(outstr);
      for k:=0 to nrrx-1 do receive_buf[k]:=ord(rxstr[k+1]);
      //  exit;
    end;

    1: begin                    //USB4all-CDC    Rs4all           Ascii
      //senden ber comport
      if not ComPort1.Connected then ComPort1.Open;
      ComPort1.ClearBuffer(true, true);
      asciistr :='#';
      for k:=0 to 15 do asciistr := asciistr + inttohex(send_buf[k],2)+'-';
      asciistr := asciistr + chr($0d);
      memo1.lines.add('ASCII_tx: '+ inttostr(Comport1.WriteStr(asciistr)));
      if CheckBox1.checked then memo1.lines.add(''+asciistr+'');

      //empfangen ber comport
      //ReadStr(var Str: String; Count: Integer): Integer;
      nrrx:=Comport1.ReadStr(rxstr, 50);
      if CheckBox1.checked then memo1.lines.add('CDC_rx: '+ inttostr(nrrx));
      if CheckBox1.checked then memo1.lines.add(''+rxstr+'');
      for k:=0 to (nrrx div 3)-1 do begin
        receive_buf[k]:=asciiwert(rxstr[3*k+2])*16 + asciiwert(rxstr[3*k+3]);
      end;
      //exit;
    end;

    0: begin                   // USB4all-MCD
      //instance ist warscheinlich 0, kann aber auch einen anderen Wert haben
      selection:=0;

      //pipes anfordern
      //fr die instance=0
      //es kann aber passieren, dass instance<>0 !!
      //da ist noch nacharbeit ntig
      myOutPipe:= _MPUSBOpen(selection,vid_pid,out_pipe,MP_WRITE,0);
      myInPipe:= _MPUSBOpen(selection,vid_pid,out_pipe,MP_READ,0);
      //habe ich pipes bekommen?
      if ((myOutPipe = INVALID_HANDLE_VALUE) or (myInPipe = INVALID_HANDLE_VALUE)) then
      begin
        Memo1.lines.add('USB Error, no pipes');
        exit;
      end;

      RecvLength:=M;
      fehler:=SendReceivePacket(send_buf,N,receive_buf,RecvLength,100,1000);
      if Fehler<>1 then  Memo1.lines.add('USB Error :'+inttostr(fehler));

      _MPUSBClose(myOutPipe);
      _MPUSBClose(myInPipe);
      myInPipe:= INVALID_HANDLE_VALUE;
      myOutPipe:=INVALID_HANDLE_VALUE;
    end;
  end; //case
end; // sende_empfange


//Programmende
procedure TForm1.Button10Click(Sender: TObject);
begin
  close;
end;



// infos ber usb treiber und brenner
// liefert false, wenn kein Brenner da ist
function TForm1.USBinfo:boolean;
var zahl : integer;
begin
  result:=false;
  memo1.lines.add('-- USB-DLL-Version : '+inttohex(_MPUSBGetDLLVersion,8));
  zahl:=_MPUSBGetDeviceCount(vid_pid);
  if zahl<1 then begin
    memo1.lines.add(' NO  sprut-device detected!');
    exit;
  end else begin
    memo1.lines.add('-- '+inttostr(zahl)+' sprut-device(s) detected');
    result:=true;
  end;
end;


//Check for Testboard
// nur fr USB4all-MCD !!
procedure TForm1.Button4Click(Sender: TObject);
begin
  Firmware     := 0;
  BootloaderDa := false;
  TbDa         := false;
  SprutDa      := USBinfo;          // fragt den Treiber nach vid_pid-Gerten
  if fakeSprutCheckBox.checked then SprutDa := true;

  if SprutDa then begin
    send_buf[0]:=READ_VERSION;    //0
    Sende_Empfange(1, 4);

    if fakeTbCheckBox.checked then receive_buf[3]:=2;
    if fakeBLCheckBox.checked then receive_buf[3]:=1;

    if (receive_buf[0] =  READ_VERSION) and (receive_buf[3]=1) then begin
      BootloaderDa:=true;
      memo1.lines.add('-- Bootloader, V. '+ IntToStr(receive_buf[2]));
    end;
    if (receive_buf[0] =  READ_VERSION) and (receive_buf[3]=2) then begin
      TbDa:=true;
      memo1.lines.add('-- USB4all, V. '+ IntToStr(receive_buf[2]));
    end;
    if (receive_buf[0] =  READ_VERSION) and (receive_buf[3]=0) then begin
      memo1.lines.add('-- Brenner8, V. '+ IntToStr(receive_buf[2]));
    end;

  end; //if brennerda
  //TbGroupBox.visible:= Tbda
end;


// Firmware Version
procedure TForm1.Button8Click(Sender: TObject);
begin
  send_buf[0]:=READ_VERSION;    //0
  send_buf[4]:= 0;   
  Sende_Empfange(1, 5);
  if(receive_buf[0] =  READ_VERSION)
    then begin
      Memo1.lines.add('Firmware version : '+ IntToStr(receive_buf[3])+'.'+IntToStr(receive_buf[2]));
      if (receive_buf[4] and $FE) = 40 then Memo1.lines.add('  40 Pins');
      if (receive_buf[4] and $FE) = 28 then Memo1.lines.add('  28 Pins');
      if (receive_buf[4] and $01) =  1 then Memo1.lines.add('  interner Oszillator');
    end else Memo1.lines.add('USB Error');
end;


//****IO*********************************************************

//IO off
procedure TForm1.Button9Click(Sender: TObject);
begin
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=0;         // off
    Sende_Empfange(16, 16);
end;

//IO init
procedure TForm1.Button13Click(Sender: TObject);
begin
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=$11;         // init
    send_buf[2]:=0;         // TRISA=0
    send_buf[3]:=0;         // TRISB=0
    send_buf[4]:=0;         // TRISC=0
    send_buf[5]:=0;         // TRISD=0
    send_buf[6]:=0;         // TRISE=0
    Sende_Empfange(16, 16);
end;
  
//IO write 55 55 55
procedure TForm1.Button14Click(Sender: TObject);
begin
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=2;         // write
    send_buf[2]:=$55;       // PORTA
    send_buf[3]:=$55;       // PORTB
    send_buf[4]:=$55;       // PORTC
    send_buf[5]:=$55;       // PORTD
    send_buf[6]:=$55;       // PORTE
    Sende_Empfange(16, 16);
end;

//IO write aa aa aa
procedure TForm1.Button79Click(Sender: TObject);
begin
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=2;         // write
    send_buf[2]:=$AA;       // PORTA
    send_buf[3]:=$AA;       // PORTB
    send_buf[4]:=$AA;       // PORTC
    send_buf[5]:=$AA;       // PORTD
    send_buf[6]:=$AA;       // PORTE
    Sende_Empfange(16, 16);
end;

//IO read
procedure TForm1.Button15Click(Sender: TObject);
begin
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=3;         // read
    Sende_Empfange(16, 16);
    memo1.lines.add( 'PortA-C: 0x'+inttohex(receive_buf[2],2)+'-0x'+inttohex(receive_buf[3],2)+'-0x'+inttohex(receive_buf[4],2)+
                   '  PortD-E: 0x'+inttohex(receive_buf[5],2)+'-0x'+inttohex(receive_buf[6],2));
end;


//****ADC*********************************************************

//ADC off
procedure TForm1.Button16Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=0;         // off
    Sende_Empfange(16, 16);
end;

//ADC init
procedure TForm1.Button17Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=1;         // init
    send_buf[2]:=5;         // AN0..AN4
    send_buf[3]:=0;         // ref
    Sende_Empfange(16, 16);
end;


//ADC init
procedure TForm1.Button120Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=1;         // init
    send_buf[2]:=10;        // AN0..AN12
    send_buf[3]:=0;         // ref
    Sende_Empfange(16, 16);
end;

//set AN0
procedure TForm1.Button18Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=0;         // AN0
    Sende_Empfange(16, 16);
end;

//set AN1
procedure TForm1.Button19Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=1;         // AN1
    Sende_Empfange(16, 16);
end;

//set AN2
procedure TForm1.Button20Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=2;         // AN2
    Sende_Empfange(16, 16);
end;

//set AN3
procedure TForm1.Button21Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=3;         // AN3
    Sende_Empfange(16, 16);
end;

//set AN4
procedure TForm1.Button119Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=4;         // AN4
    Sende_Empfange(16, 16);
end;

//set AN8
procedure TForm1.Button121Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=5;         // AN8
    Sende_Empfange(16, 16);
end;

//set AN9
procedure TForm1.Button122Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=6;         // AN9
    Sende_Empfange(16, 16);
end;

//set AN10
procedure TForm1.Button123Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=7;         // AN10
    Sende_Empfange(16, 16);
end;

//set AN11
procedure TForm1.Button124Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=8;         // AN11
    Sende_Empfange(16, 16);
end;

//set AN12
procedure TForm1.Button125Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=2;         // set AN
    send_buf[2]:=9;         // AN12
    Sende_Empfange(16, 16);
end;

//ADC read
procedure TForm1.Button22Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_ADC;   // ADC
    send_buf[1]:=3;         // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           //high
    wert:=wert*256+ receive_buf[2]; //low
    if ADCRadioGroup.itemindex=0 then
      memo1.lines.add('ADC: '+inttostr(wert)+' = '+inttostr(round(wert*5000/1024))+'mV')
    else
      memo1.lines.add('ADC: '+inttostr(wert)+' = '+inttostr(round(wert*5000/4096))+'mV');
end;


//****RS232*********************************************************

//RS232 off
procedure TForm1.Button23Click(Sender: TObject);
begin
    send_buf[0]:=SYS_RS232;   // RS232
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

//init RS232
procedure TForm1.Button24Click(Sender: TObject);
begin
    send_buf[0]:=SYS_RS232;   // ADC
    send_buf[1]:=1;           // init
    send_buf[2]:=0;           // 19200  default
    Sende_Empfange(16, 16);
end;

//send RS232
procedure TForm1.Button25Click(Sender: TObject);
begin
    send_buf[0]:=SYS_RS232; // RS232
    send_buf[1]:=2;         // send
    send_buf[2]:=ord('a');  // 'a'
    Sende_Empfange(16, 16);
end;

//enpfange RS232
procedure TForm1.Button26Click(Sender: TObject);
begin
    send_buf[0]:=SYS_RS232; // RS232
    send_buf[1]:=3;         // read
    Sende_Empfange(16, 16);
    if  receive_buf[0] = 0 then memo1.lines.add('RS232: 0x'+ inttohex(receive_buf[2],2)+' = '''+chr(receive_buf[2])+'''')
                           else memo1.lines.add('RS232: keine Daten');
end;

//read String via RS232
procedure TForm1.Button126Click(Sender: TObject);
var k : integer;
    st : string;
begin
    send_buf[0]:=SYS_RS232; // RS232
    send_buf[1]:=5;         // read string
    send_buf[2]:=20;         // laenge
    Sende_Empfange(16, 16);
    st := '';
    if receive_buf[2]>0 then for k:=0 to (receive_buf[2]-1) do st:=st+char(receive_buf[3+k]);
    memo1.lines.add('RS232: '+inttostr(receive_buf[2])+' Zeichen gelesen >>'+st+'<<');
end;

//how many in buffer
procedure TForm1.Button128Click(Sender: TObject);
begin
    send_buf[0]:=SYS_RS232; // RS232
    send_buf[1]:=6;         // fuellstand
    Sende_Empfange(16, 16);
    memo1.lines.add('RS232: '+inttostr(receive_buf[2])+' Zeichen im Puffer');
end;

//Flush Buffer
procedure TForm1.Button127Click(Sender: TObject);
begin
    send_buf[0]:=SYS_RS232; // RS232
    send_buf[1]:=7;         // Flush
    Sende_Empfange(16, 16);
end;



//****I2C*********************************************************

//I2C off
procedure TForm1.Button27Click(Sender: TObject);
begin
    send_buf[0]:=SYS_I2C;     // I2C
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

// I2C init
procedure TForm1.Button28Click(Sender: TObject);
begin
    send_buf[0]:=SYS_I2C;     // I2C
    send_buf[1]:=1;           // init
    send_buf[2]:=0;           // master
    send_buf[3]:=0;           // 100 kHz, i2cslew = SLEW_OFF;
    Sende_Empfange(16, 16);
end;

// I2C senden
procedure TForm1.Button29Click(Sender: TObject);
begin
    send_buf[0]:=SYS_I2C;   // I2C
    send_buf[1]:=2;         // send
    send_buf[2]:=$20;       // Adresse 8444
    send_buf[3]:=$00;       // 
    Sende_Empfange(16, 16);
    if (receive_buf[0]<>0) then memo1.lines.add('Error: 0x'+ inttohex(receive_buf[0],2));
end;

//empfange I2C
procedure TForm1.Button30Click(Sender: TObject);
begin
    send_buf[0]:=SYS_I2C;   // I2C
    send_buf[1]:=3;         // read
    send_buf[2]:=$48;       // Adresse     100 1000 , LM75 (A0..A2=0)
    Sende_Empfange(16, 16);
    if (receive_buf[0]<>0) then memo1.lines.add('Error: 0x'+ inttohex(receive_buf[0],2));
    memo1.lines.add('I2C: 0x'+ inttohex(receive_buf[2],2)+' = '''+chr(receive_buf[2])+'''');
end;

// Temperatur vom LM75 auslesen
procedure TForm1.Button58Click(Sender: TObject);
var a : char;
begin
    send_buf[0]:=SYS_I2C;   // I2C
    send_buf[1]:=5;         // Blockread
    send_buf[2]:=$48;       // Adresse     100 1000  , LM75 (A0..A2=0)
//    send_buf[2]:=$91;       // Adresse     1001 0001 , LM75 (A0..A2=0)
    send_buf[3]:=$02;       // 2 Bytes
    Sende_Empfange(16, 16);
    a:='0';
    if (receive_buf[0]<>0) then memo1.lines.add('Error: 0x'+ inttohex(receive_buf[0],2));
    if  (receive_buf[5] and $80)<>0 then a:='5';
    memo1.lines.add('LM75: '+ inttohex(receive_buf[4],2)+'  ' + inttohex(receive_buf[5],2)+
         ' = '+inttostr(receive_buf[4])+','+a+'');
end;

procedure TForm1.Button59Click(Sender: TObject);
begin
    send_buf[0]:=SYS_I2C;   // I2C
    send_buf[1]:=4;         // Block send
    send_buf[2]:=$20;       // Adresse 8444
//    send_buf[2]:=$40;       // Adresse 8444
    send_buf[3] :=$08;      // 8 Bytes

    send_buf[4] :=$00;      //  Einschreiben beginnend ab DAC0
    send_buf[5] :=$00;      //  DAC0=0V
    send_buf[6] :=$01;      //  DAC1=?V
    send_buf[7] :=$02;      //  DAC2=?V
    send_buf[8] :=$04;      //  DAC3=?V
    send_buf[9] :=$08;      //  DAC4=?V
    send_buf[10]:=$10;      //  DAC5=?V
    send_buf[11]:=$20;      //  DAC6=?V
    Sende_Empfange(16, 16);
    if (receive_buf[0]<>0) then memo1.lines.add('Error: 0x'+ inttohex(receive_buf[0],2));
end;

procedure TForm1.Button60Click(Sender: TObject);
begin
    send_buf[0]:=SYS_I2C;   // I2C
    send_buf[1] :=4;         // Block send
    send_buf[2] :=$20;       // Adresse   8444
//    send_buf[2] :=$40;       // Adresse   8444
    send_buf[3] :=$08;       // 8 Bytes

    send_buf[4] :=$00;      //  Einschreiben beginnend ab DAC0
    send_buf[5] :=$20;      //  DAC0=?V
    send_buf[6] :=$10;      //  DAC1=?V
    send_buf[7] :=$08;      //  DAC2=?V
    send_buf[8] :=$04;      //  DAC3=?V
    send_buf[9] :=$02;      //  DAC4=?V
    send_buf[10]:=$01;      //  DAC5=?V
    send_buf[11]:=$00;      //  DAC6=0V
    Sende_Empfange(16, 16);
    if (receive_buf[0]<>0) then memo1.lines.add('Error: 0x'+ inttohex(receive_buf[0],2));    
end;


//****LCD*********************************************************

//LCD off
procedure TForm1.Button31Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;    // LCD1
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

//init LCD
procedure TForm1.Button32Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;    // LCD1
    send_buf[1]:=1;           // init
    send_buf[2]:=2;           // zeilen
    send_buf[3]:=16;          // zeichen pro zeile
    Sende_Empfange(16, 16);
end;

//send LCD
procedure TForm1.Button33Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=2;         // send
    send_buf[2]:=ord('A');  // 'A'
    Sende_Empfange(16, 16);
end;

//control LCD
procedure TForm1.Button34Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=3;         // control
    send_buf[2]:=1;         // loeschen
    Sende_Empfange(16, 16);
end;

//Block send LCD
procedure TForm1.Button35Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=4;         // Block send
    send_buf[2]:=5;         // 5 Zeichen
    send_buf[3]:=ord('H');  // 'H'
    send_buf[4]:=ord('a');  // 'a'
    send_buf[5]:=ord('l');  // 'l'
    send_buf[6]:=ord('l');  // 'l'
    send_buf[7]:=ord('o');  // 'o'
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button44Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=3;         // control
    send_buf[2]:=1;         // loeschen
    Sende_Empfange(16, 16);

    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=4;         // Block send
    send_buf[2]:=5;         // 5 Zeichen
    send_buf[3]:=ord('H');  // 'H'
    send_buf[4]:=ord('a');  // 'a'
    send_buf[5]:=ord('l');  // 'l'
    send_buf[6]:=ord('l');  // 'l'
    send_buf[7]:=ord('o');  // 'o'
    Sende_Empfange(16, 16);

    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=3;         // control
    send_buf[2]:=$C0;       // 2. Zeile
    Sende_Empfange(16, 16);

    send_buf[0]:=SYS_LCD1;  // LCD1
    send_buf[1]:=4;         // Block send
    send_buf[2]:=4;         // 5 Zeichen
    send_buf[3]:=ord('W');  // 'W'
    send_buf[4]:=ord('e');  // 'e'
    send_buf[5]:=ord('l');  // 'l'
    send_buf[6]:=ord('t');  // 't'
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button45Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;    // LCD1
    send_buf[1]:=1;           // init
    send_buf[2]:=1;           // zeilen
    send_buf[3]:=16;          // zeichen pro zeile
    Sende_Empfange(16, 16);
end;


procedure TForm1.Button68Click(Sender: TObject);
begin
    send_buf[0]:=SYS_LCD1;    // LCD1
    send_buf[1]:=6;           // gehe zu position
    send_buf[2]:=1;           // 2. Zeile
    send_buf[3]:=8;           // 9. Spalte
    Sende_Empfange(16, 16);
end;

//****interner EEPROM*********************************************************

//schreibe ein byte
procedure TForm1.Button36Click(Sender: TObject);
begin
    send_buf[0]:=SYS_EEPROM;// EE
    send_buf[1]:=2;         // send
    send_buf[2]:=$0;        // Adresse
    send_buf[3]:=$55;       // 0x55
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button80Click(Sender: TObject);
begin
    send_buf[0]:=SYS_EEPROM;// EE
    send_buf[1]:=2;         // send
    send_buf[2]:=$0;        // Adresse
    send_buf[3]:=$22;       // 0x22
    Sende_Empfange(16, 16);
end;

//lese ein Byte
procedure TForm1.Button37Click(Sender: TObject);
begin
    send_buf[0]:=SYS_EEPROM;// EE
    send_buf[1]:=3;         // read
    send_buf[2]:=$0;        // Adresse
    Sende_Empfange(16, 16);
    memo1.lines.add('EE: (0x'+ inttohex(send_buf[2],2)+') = 0x'+ inttohex(receive_buf[3],2));
end;

//schreibe block
procedure TForm1.Button38Click(Sender: TObject);
begin
    send_buf[0]:=SYS_EEPROM;// EE
    send_buf[1]:=4;         // Block send
    send_buf[2]:=$00;       // Adresse
    send_buf[3]:=$05;       // 5 Bytes
    send_buf[4]:=$01;       //
    send_buf[5]:=$02;       //
    send_buf[6]:=$03;       //
    send_buf[7]:=$04;       //
    send_buf[8]:=$05;       //
    Sende_Empfange(16, 16);
end;

//schreibe block
procedure TForm1.Button81Click(Sender: TObject);
begin
    send_buf[0]:=SYS_EEPROM;// EE
    send_buf[1]:=4;         // Block send
    send_buf[2]:=$00;       // Adresse
    send_buf[3]:=$05;       // 5 Bytes
    send_buf[4]:=$05;       //
    send_buf[5]:=$04;       //
    send_buf[6]:=$03;       //
    send_buf[7]:=$02;       //
    send_buf[8]:=$01;       //
    Sende_Empfange(16, 16);
end;

//lese block
procedure TForm1.Button39Click(Sender: TObject);
var k : integer;
begin
    send_buf[0]:=SYS_EEPROM;// EE
    send_buf[1]:=5;         // Blockread
    send_buf[2]:=$00;       // Adresse
    send_buf[3]:=$05;       // 5 Bytes
    Sende_Empfange(16, 16);
    for k:= 0 to send_buf[3]-1 do
      memo1.lines.add('EE: (0x'+ inttohex(send_buf[2]+k,2)+') = 0x'+ inttohex(receive_buf[4+k],2));
end;




//****PWM1*********************************************************

//PWM1 off
procedure TForm1.Button40Click(Sender: TObject);
begin
    send_buf[0]:=SYS_PWM1;    // PWM1
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

//init PWM1
procedure TForm1.Button41Click(Sender: TObject);
begin
    send_buf[0]:=SYS_PWM1;    // PWM1
    send_buf[1]:=1;           // init
    send_buf[2]:=pwmcombobox.itemindex;
    Sende_Empfange(16, 16);
    case pwmcombobox.itemindex of
    0,4,5,6: pwmmax := 255;
    1,2,3  : pwmmax := 99;
    7,8,9  : pwmmax := 1023;
    end;
end;

// DC=50%
procedure TForm1.Button42Click(Sender: TObject);
var dc : integer;
begin
    dc := round(pwmmax*0.5);
    send_buf[0]:=SYS_PWM1;    // PWM1
    send_buf[1]:=2;           // DC
    send_buf[2]:=dc mod $100; // low
    send_buf[3]:=dc div $100; // high
    Sende_Empfange(16, 16);
end;

//dc = 75%
procedure TForm1.Button43Click(Sender: TObject);
var dc : integer;
begin
    dc := round(pwmmax*0.75);
    send_buf[0]:=SYS_PWM1;    // PWM1
    send_buf[1]:=2;           // DC
    send_buf[2]:=dc mod $100; // low
    send_buf[3]:=dc div $100; // high
    Sende_Empfange(16, 16);
end;


procedure TForm1.TrackBar1Change(Sender: TObject);
var dc : integer;
begin
    dc := round(pwmmax * (100-TrackBar1.Position) / 100);
    send_buf[0]:=SYS_PWM1;    // PWM1
    send_buf[1]:=2;           // DC
    send_buf[2]:=dc mod $100; // low
    send_buf[3]:=dc div $100; // high
    Sende_Empfange(16, 16);

    dc := round(pwmmax * TrackBar1.Position / 100);
    send_buf[0]:=SYS_PWM2;    // PWM2
    send_buf[1]:=2;           // DC
    send_buf[2]:=dc mod $100; // low
    send_buf[3]:=dc div $100; // high
    Sende_Empfange(16, 16);
end;


//****PWM2*********************************************************

//pwm2 off
procedure TForm1.Button3Click(Sender: TObject);
begin
    send_buf[0]:=SYS_PWM2;    // PWM2
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

//pwm2 init
procedure TForm1.Button6Click(Sender: TObject);
begin
    send_buf[0]:=SYS_PWM2;    // PWM2
    send_buf[1]:=1;           // init
    send_buf[2]:=pwmcombobox.itemindex;
    Sende_Empfange(16, 16);
    case pwmcombobox.itemindex of
    0,4,5,6: pwmmax := 255;
    1,2,3  : pwmmax := 99;
    7,8,9  : pwmmax := 1023;
    end;
end;

//dc=50%
procedure TForm1.Button7Click(Sender: TObject);
var dc : integer;
begin
    dc := round(pwmmax*0.5);
    send_buf[0]:=SYS_PWM2;    // PWM2
    send_buf[1]:=2;           // DC
    send_buf[2]:=dc mod $100; // low
    send_buf[3]:=dc div $100; // high
    Sende_Empfange(16, 16);
end;

//dc=75%
procedure TForm1.Button11Click(Sender: TObject);
var dc : integer;
begin
    dc := round(pwmmax*0.75);
    send_buf[0]:=SYS_PWM2;    // PWM2
    send_buf[1]:=2;           // DC
    send_buf[2]:=dc mod $100; // low
    send_buf[3]:=dc div $100; // high
    Sende_Empfange(16, 16);
end;


//****STEP1*********************************************************

// Schrittmotor 1 abschalten
procedure TForm1.Button12Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

// Schrittmotor 1 einschalten
procedure TForm1.Button46Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=1;           // on
    Sende_Empfange(16, 16);
end;


// [2] - lower 8 bit
// [3] - upper 8 bit
// [4] - 0+0: halb - rechts
//     	 0+1: halb - links
//     	 2+0: voll - rechts
//     	 2+1: voll - links
//     	 4  : synchron
//     	 8  : power off
// [5] - Periode im ms (0=default= 100 Hz)

// 100 steps links halbschritt
procedure TForm1.Button47Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=100;         // 100
    send_buf[3]:=0;           //
    send_buf[4]:=1+4;         // LH
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=0;           // 1000 Hz
    Sende_Empfange(16, 16);
end;

// 50 Schritt rechts Vollschritt
procedure TForm1.Button48Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=50;          // 50
    send_buf[3]:=0;           //
    send_buf[4]:=2+4;         // LH
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=0;           // 1000 Hz
    Sende_Empfange(16, 16);
end;

// 8 links halb slow
procedure TForm1.Button49Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=8;           // 8
    send_buf[3]:=0;           //
    send_buf[4]:=1+4;         // LH
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=250;         // 4 Hz
    Sende_Empfange(16, 16);
end;

// 4 rechts voll slow
procedure TForm1.Button50Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=4;           // 4
    send_buf[3]:=0;           //
    send_buf[4]:=2+4;         // RV
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=250;         // 4 Hz
    Sende_Empfange(16, 16);
end;

//****STEP2*********************************************************

// Schrittmotor 2 abschalten
procedure TForm1.Button51Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

// Schrittmotor 2 einschalten
procedure TForm1.Button52Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=1;           // on
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button53Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=$10;         // 10000
    send_buf[3]:=$27;         //
    send_buf[4]:=1;           // LH  a
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=0;           // 1000 Hz
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button54Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=50;          // 50
    send_buf[3]:=0;           //
    send_buf[4]:=2;           // RH
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=0;           // 1000 Hz
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button55Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=80;          // 80
    send_buf[3]:=0;           //
    send_buf[4]:=1;           // LH
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=250;         // 4 Hz
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button56Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=40;          // 40
    send_buf[3]:=0;           //
    send_buf[4]:=2;           // RV
    if Step1CheckBox.checked then send_buf[4]:= send_buf[4] + 8;  // power off
    send_buf[5]:=250;         // 4 Hz
    Sende_Empfange(16, 16);
end;

//schritte fr motor 2 auslesen
procedure TForm1.Button57Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_STEP2;
    send_buf[1]:=3;                 // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           // high
    wert:=wert*256+ receive_buf[2]; // low
    memo1.lines.add('Steps2: '+inttostr(wert));
end;


//****L297**************************************************

// L297_1 abschalten
procedure TForm1.Button61Click(Sender: TObject);
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

// L297_1 einschalten
procedure TForm1.Button62Click(Sender: TObject);
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=1;           // on
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button63Click(Sender: TObject);
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=$10;         // 10000
    send_buf[3]:=$27;         //
    send_buf[4]:=1;           // L  a
    send_buf[5]:=0;           // 1000 Hz
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button64Click(Sender: TObject);
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=50;          // 50
    send_buf[3]:=0;           //
    send_buf[4]:=2;           // L
    send_buf[5]:=0;           // 1000 Hz
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button65Click(Sender: TObject);
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=80;          // 80
    send_buf[3]:=0;           //
    send_buf[4]:=1;           // L
    send_buf[5]:=250;         // 4 Hz
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button66Click(Sender: TObject);
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=2;           // dreh
    send_buf[2]:=40;          // 40
    send_buf[3]:=0;           //
    send_buf[4]:=2;           // R
    send_buf[5]:=250;         // 4 Hz
    Sende_Empfange(16, 16);
end;

//schritte fr L297 auslesen
procedure TForm1.Button67Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_L297_1;
    send_buf[1]:=3;                 // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           //high
    wert:=wert*256+ receive_buf[2]; //low
    memo1.lines.add('L297_1: '+inttostr(wert));
end;

//****allgemein*************************************************

procedure TForm1.FormCreate(Sender: TObject);
begin
//DEBUG
//  fakeTbCheckBox.visible:=false;
//  fakeBLCheckBox.visible:=false;
//  fakeSprutCheckBox.visible:=false;

  Application.HintHidePause := 10000;       // Wert in Millisekunden
  Application.HintPause := 100;             // Wert in Millisekunden

  SB0CheckBox.checked   := true;
  pwmcombobox.itemindex := 0;

  Button107.visible := false;
  Button108.visible := false;

//  rs4all := true;

  if rs4all then begin
    Caption         := 'Rs-4-all 1.16';
    Comport1.port   := 'COM1';
    Button1.visible := false;
    Button2.visible := false;
    Button4.visible := false;
    vers_RadioGroup.itemindex := 1;
    vers_RadioGroup.visible := false;
    Button5.caption       := 'Reset Rs4all';
    TabSheet8.TabVisible  := false;
    TabSheet12.TabVisible := false;
    TabSheet13.TabVisible := false;
    Button100.visible := false;
    Button104.visible := false;
    Button106.visible := false;
    Button102.visible := false;
    CheckBox1.caption := 'RS232-blablabla';
    Button75.hint := 'COM-Port fr Rs4all einstellen';
    Button5.hint  := 'Rs4all zurcksetzen';
  end;
end;


procedure TForm1.AsciiCheckBoxClick(Sender: TObject);
begin
  Comport1.open;
end;


procedure TForm1.Button75Click(Sender: TObject);
begin
  Comport1.ShowSetupDialog;
end;


procedure TForm1.vers_RadioGroupClick(Sender: TObject);
begin
  if vers_RadioGroup.itemindex>0 then begin
    if not ComPort1.Connected then ComPort1.Open;
  end;
  Button1.enabled:= vers_RadioGroup.itemindex=0;
  Button2.enabled:= vers_RadioGroup.itemindex=0;
  Button4.enabled:= vers_RadioGroup.itemindex=0;
end;

//****FREQUENZ**************************************************

//Frequenzmesser automatisch
procedure TForm1.Button69Click(Sender: TObject);
var wert : longint;
begin
    send_buf[0]:=SYS_FRQ;   // Frequenzmesser
    send_buf[1]:=5;         // auto
    Sende_Empfange(16, 16);
    wert:=receive_buf[5];           //high
    wert:=wert*256+ receive_buf[4]; //low
    wert:=wert*256+ receive_buf[3]; //low
    wert:=wert*256+ receive_buf[2]; //low
    memo1.lines.add('Frq: '+inttostr(wert)+' Hz');
end;


function toleranz(wert : integer):string;
begin
  result := '';
  if wert>0 then result := ' +-' + inttostr(round(100/wert)) + '%';
end;

//Frequenzmesser manuell
//Zhlfrequenzmesser mit 64:1 Vorteiler und 10 ms Messzeit
procedure TForm1.Button70Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_FRQ;   // Frequenzmesser
    send_buf[1]:=3;         // manuell
    send_buf[2]:=5;         // vorteiler 64:1
    send_buf[3]:=0;         // messzeit  10 ms
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           //high
    wert:=wert*256+ receive_buf[2]; //low
    memo1.lines.add('Frq: '+inttostr(wert)+' Pulse -> '+inttostr(wert*64*100)+' Hz ' + toleranz(wert));
end;

procedure TForm1.Button129Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_FRQ;   // Frequenzmesser
    send_buf[1]:=3;         // manuell
    send_buf[2]:=3;         // vorteiler 16:1
    send_buf[3]:=0;         // messzeit  10 ms
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           //high
    wert:=wert*256+ receive_buf[2]; //low
    memo1.lines.add('Frq: '+inttostr(wert)+' Pulse -> '+inttostr(wert*16*100)+' Hz' + toleranz(wert));
end;

procedure TForm1.Button130Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_FRQ;   // Frequenzmesser
    send_buf[1]:=3;         // manuell
    send_buf[2]:=1;         // vorteiler 4:1
    send_buf[3]:=0;         // messzeit  10 ms
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           //high
    wert:=wert*256+ receive_buf[2]; //low
    memo1.lines.add('Frq: '+inttostr(wert)+' Pulse -> '+inttostr(wert*4*100)+' Hz' + toleranz(wert));
end;

procedure TForm1.Button131Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_FRQ;   // Frequenzmesser
    send_buf[1]:=3;         // manuell
    send_buf[2]:=3;         // vorteiler 16:1
    send_buf[3]:=3;         // messzeit  100 ms
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           //high
    wert:=wert*256+ receive_buf[2]; //low
    memo1.lines.add('Frq: '+inttostr(wert)+' Pulse -> '+inttostr(wert*16*10)+' Hz' + toleranz(wert));
end;


//****SERVOs********************************************************

// off ServoB
procedure TForm1.Button72Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ServoB;   // ServoB
    send_buf[1]:=0;            // off
    Sende_Empfange(16, 16);
end;

// off ServoC
procedure TForm1.Button74Click(Sender: TObject);
begin
    send_buf[0]:=SYS_ServoC;   // ServoC
    send_buf[1]:=0;            // off
    Sende_Empfange(16, 16);
end;

// on ServoB  aktivieren
procedure TForm1.Button71Click(Sender: TObject);
var maske : byte;
begin
    send_buf[0]:=SYS_ServoB;   // ServoB
    send_buf[1]:=1;            // on
    maske:=0;
    if SB0CheckBox.checked then maske := maske or $01;
    if SB1CheckBox.checked then maske := maske or $02;
    if SB2CheckBox.checked then maske := maske or $04;
    if SB3CheckBox.checked then maske := maske or $08;
    if SB4CheckBox.checked then maske := maske or $10;
    if SB5CheckBox.checked then maske := maske or $20;
    if SB6CheckBox.checked then maske := maske or $40;
    if SB7CheckBox.checked then maske := maske or $80;
    send_buf[2]:=maske;
    Sende_Empfange(16, 16);
end;

// on ServoC aktivieren
procedure TForm1.Button73Click(Sender: TObject);
var maske : byte;
begin
    send_buf[0]:=SYS_ServoC;   // ServoC
    send_buf[1]:=1;            // on
    maske:=0;
    if SC0CheckBox.checked then maske := maske or $01;
    if SC1CheckBox.checked then maske := maske or $02;
    if SC2CheckBox.checked then maske := maske or $04;
    if SC6CheckBox.checked then maske := maske or $40;
    if SC7CheckBox.checked then maske := maske or $80;
    send_buf[2]:=maske;
    Sende_Empfange(16, 16);
end;

// ServoB bewegen
procedure TForm1.SB0TrackBarChange(Sender: TObject);
begin
    send_buf[0]:=SYS_ServoB;   // ServoB
    send_buf[1]:=2;
    send_buf[2]:=SB0Trackbar.position;
    send_buf[3]:=SB1Trackbar.position;
    send_buf[4]:=SB2Trackbar.position;
    send_buf[5]:=SB3Trackbar.position;
    send_buf[6]:=SB4Trackbar.position;
    send_buf[7]:=SB5Trackbar.position;
    send_buf[8]:=SB6Trackbar.position;
    send_buf[9]:=SB7Trackbar.position;
    memo1.lines.add('Servo-B: '+inttohex(send_buf[1],2)+': '+inttohex(send_buf[2],2)+'  '
      +inttohex(send_buf[3],2)+'  '+inttohex(send_buf[4],2)+'  '+inttohex(send_buf[5],2)+'  '+inttohex(send_buf[6],2)+'  '
      +inttohex(send_buf[7],2)+'  '+inttohex(send_buf[8],2)+'  '+inttohex(send_buf[9],2));
    Sende_Empfange(16, 16);
end;

// ServoC bewegen
procedure TForm1.SC0TrackBarChange(Sender: TObject);
begin
    send_buf[0]:=SYS_ServoC;   // ServoC
    send_buf[1]:=2;
    send_buf[2]:=SC0Trackbar.position;
    send_buf[3]:=SC1Trackbar.position;
    send_buf[4]:=SC2Trackbar.position;
    send_buf[5]:=0;
    send_buf[6]:=0;
    send_buf[7]:=0;
    send_buf[8]:=SC6Trackbar.position;
    send_buf[9]:=SC7Trackbar.position;
    memo1.lines.add('Servo-C: '+inttohex(send_buf[1],2)+': '+inttohex(send_buf[2],2)+'  '
      +inttohex(send_buf[3],2)+'  '+inttohex(send_buf[4],2)+'  '+inttohex(send_buf[5],2)+'  '+inttohex(send_buf[6],2)+'  '
      +inttohex(send_buf[7],2)+'  '+inttohex(send_buf[8],2)+'  '+inttohex(send_buf[9],2));
    Sende_Empfange(16, 16);
end;


procedure TForm1.SB0CheckBoxClick(Sender: TObject);
begin
  SB0TrackBar.Enabled := SB0CheckBox.checked;
  SB1TrackBar.Enabled := SB1CheckBox.checked;
  SB2TrackBar.Enabled := SB2CheckBox.checked;
  SB3TrackBar.Enabled := SB3CheckBox.checked;
  SB4TrackBar.Enabled := SB4CheckBox.checked;
  SB5TrackBar.Enabled := SB5CheckBox.checked;
  SB6TrackBar.Enabled := SB6CheckBox.checked;
  SB7TrackBar.Enabled := SB7CheckBox.checked;

  SC0TrackBar.Enabled := SC0CheckBox.checked;
  SC1TrackBar.Enabled := SC1CheckBox.checked;
  SC2TrackBar.Enabled := SC2CheckBox.checked;
  SC6TrackBar.Enabled := SC6CheckBox.checked;
  SC7TrackBar.Enabled := SC7CheckBox.checked;
end;

//****Schieberegister******************************************************

// Schieberegister einschalten
procedure TForm1.Button76Click(Sender: TObject);
var maske : byte;
begin
    //ich brauche RB2 als load-Puls
    //load-pin auf output
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=5;         // write
    send_buf[2]:=$00;       // TRISA
    send_buf[3]:=$04;       // TRISB         RB2-out
    send_buf[4]:=$00;       // TRISC
    Sende_Empfange(16, 16);
    //load-pin auf low
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=7;         // write
    send_buf[2]:=$00;       // PORTA
    send_buf[3]:=$04;       // PORTB
    send_buf[4]:=$00;       // PORTC
    Sende_Empfange(16, 16);
    //SR
    send_buf[0]:=SYS_SR;       // Schieberegister
    send_buf[1]:=1;            // on
    maske := (SrClkRadioGroup.ItemIndex * 16) + SrModeRadioGroup.ItemIndex;
    send_buf[2]:=maske;
    Sende_Empfange(16, 16);
end;

// Schieberegister abschalten
procedure TForm1.Button77Click(Sender: TObject);
begin
    send_buf[0]:=SYS_SR;        // Schieberegister
    send_buf[1]:=0;            // off
    Sende_Empfange(16, 16);

    //load-pin auf input
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=4;         // write
    send_buf[2]:=$00;       // TRISA
    send_buf[3]:=$04;       // TRISB         RB2-in
    send_buf[4]:=$00;       // TRISC
    Sende_Empfange(16, 16);
end;

// Schieberegister senden
procedure TForm1.Button78Click(Sender: TObject);
var maske : word;
begin
    send_buf[0]:= SYS_SR;       // Schieberegister
    send_buf[1]:= 2;            // senden
    send_buf[2]:= 2;            // 2 bytes
    maske := SRTrackBar.position * 1000;  // 0 .. 50000
    send_buf[3]:= maske div $100;
    send_buf[4]:= maske mod $100;
    memo1.lines.add('SR-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+': '+inttohex(send_buf[3],2)+'  '+inttohex(send_buf[4],2)+' =  '+inttostr(maske)+' Hz');
    Sende_Empfange(16, 16);
    memo1.lines.add('SR-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+': '+inttohex(receive_buf[3],2)+'  '+inttohex(receive_buf[4],2));

    //load-pin auf high
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=6;         // write
    send_buf[2]:=$00;       // PORTA
    send_buf[3]:=$04;       // PORTB
    send_buf[4]:=$00;       // PORTC
    Sende_Empfange(16, 16);
    sleep(1);

    //load-pin auf low
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=7;         // write
    send_buf[2]:=$00;       // PORTA
    send_buf[3]:=$04;       // PORTB
    send_buf[4]:=$00;       // PORTC
    Sende_Empfange(16, 16);
end;

procedure TForm1.SRTrackBarChange(Sender: TObject);
begin
  label32.caption := inttostr(round(SRTrackBar.position * 1003.868))+' Hz  /  '
  +inttostr(round(SRTrackBar.position * 200))+' Hz';
end;


//****SPI*********************************************************

// SPI initialisieren
procedure TForm1.Button82Click(Sender: TObject);
begin
    //SPI
    send_buf[0]:=SYS_SPI;       // SPI
    send_buf[1]:=1;             // on
    send_buf[2]:=SpiSlavesRadioGroup.itemindex; // anzahl der SL-Leitungen
    send_buf[3]:=SpiClkRadioGroup.itemindex;    // Takt, Master/Slave
    send_buf[4]:=SpiModeRadioGroup.itemindex;
    send_buf[5]:=SpiSampleRadioGroup.itemindex; // Samplezeitpunkt
    memo1.lines.add('SPI-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+'  '+inttohex(send_buf[3],2)
                    +'  '+inttohex(send_buf[4],2)+'  '+inttohex(send_buf[5],2));
    Sende_Empfange(16, 16);
    memo1.lines.add('SPI-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+'  '+inttohex(receive_buf[3],2));
end;

// SPI off
procedure TForm1.Button83Click(Sender: TObject);
begin
    send_buf[0]:=SYS_SPI;      // SPI
    send_buf[1]:=0;            // off
    Sende_Empfange(16, 16);
end;

// SPI senden
procedure TForm1.Button84Click(Sender: TObject);
begin
    send_buf[0]:= SYS_SPI;      // SPI
    send_buf[1]:= 2;            // senden
    send_buf[2]:= SpiCsRadioGroup.itemindex; //nummer des slaves
    if csaktivCheckBox.checked then send_buf[2]:=send_buf[2] + $40;
    send_buf[3]:= $55;          // byte
    memo1.lines.add('SPI-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+'  '+inttohex(send_buf[3],2));
    Sende_Empfange(16, 16);
    memo1.lines.add('SPI-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+'  '+inttohex(receive_buf[3],2));
end;

// SPI empfangen
procedure TForm1.Button85Click(Sender: TObject);
begin
    send_buf[0]:= SYS_SPI;      // SPI
    send_buf[1]:= 3;            // empfange
    send_buf[2]:= SpiCsRadioGroup.itemindex; //nummer des slaves
    if csaktivCheckBox.checked then send_buf[2]:=send_buf[2] + $40;
    memo1.lines.add('SPI-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2));
    Sende_Empfange(16, 16);
    memo1.lines.add('SPI-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+'  '+inttohex(receive_buf[3],2));
end;

//spi block senden
procedure TForm1.Button90Click(Sender: TObject);
begin
    send_buf[0]:= SYS_SPI;      // SPI
    send_buf[1]:= 4;            // senden block
    send_buf[2]:= SpiCsRadioGroup.itemindex; //nummer des slaves
    if spiCsCheckbox.checked   then send_buf[2]:=send_buf[2] + $80;
    if csaktivCheckBox.checked then send_buf[2]:=send_buf[2] + $40;
    send_buf[3]:= 4;            // 4 byte
    send_buf[4]:= 1;            // 1. byte
    send_buf[5]:= 2;            // 2. byte
    send_buf[6]:= 3;            // 3. byte
    send_buf[7]:= 4;            // 4. byte

    memo1.lines.add('SPI-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+'  '+inttohex(send_buf[3],2)
                    +'  '+inttohex(send_buf[4],2)+'  '+inttohex(send_buf[5],2)+'  '+inttohex(send_buf[6],2)+'  '+inttohex(send_buf[7],2));
    Sende_Empfange(16, 16);
    memo1.lines.add('SPI-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+'  '+inttohex(receive_buf[3],2));
end;


//****M-Wire*********************************************************

//microwire initialisieren
procedure TForm1.Button86Click(Sender: TObject);
begin
    send_buf[0]:=SYS_MWIRE;       // microwire
    send_buf[1]:=1;               // on
    send_buf[2]:=MwClkRadioGroup.ItemIndex;
    Sende_Empfange(16, 16);
end;

//microwire senden
procedure TForm1.Button87Click(Sender: TObject);
begin
    send_buf[0]:= SYS_MWIRE;       // microwire
    send_buf[1]:= 2;               // senden
    send_buf[2]:= $55;             // byte
    send_buf[3]:= $00;             // nicht warten
    memo1.lines.add('mWire-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+'  '+inttohex(send_buf[3],2));
    Sende_Empfange(16, 16);
    memo1.lines.add('mWire-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+'  '+inttohex(receive_buf[3],2));
end;

//microwire empfangen
procedure TForm1.Button88Click(Sender: TObject);
begin
    send_buf[0]:= SYS_MWIRE;       // microwire
    send_buf[1]:= 3;               // empfange
    send_buf[2]:= 0;               // low
    send_buf[3]:= 0;               // high
    memo1.lines.add('mWire-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+'  '+inttohex(send_buf[3],2));
    Sende_Empfange(16, 16);
    memo1.lines.add('mWire-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+'  '+inttohex(receive_buf[3],2));
end;

//microwire abschalten
procedure TForm1.Button89Click(Sender: TObject);
begin
    send_buf[0]:=SYS_MWIRE;    // microwire
    send_buf[1]:=0;            // off
    Sende_Empfange(16, 16);
end;

//****ENDE*********************************************************



procedure TForm1.Button95Click(Sender: TObject);
begin
  runsteps(1);
end;


procedure TForm1.Button96Click(Sender: TObject);
begin
  runsteps(2);
end;

procedure TForm1.runsteps(kanal: integer);
var
    links,
    vollschritt,
    synchron,
    poweroff,
    wave,
    beschleunigen,
    mal10     : integer;
begin
    send_buf[0]:= SYS_STEP1;
    if Kanal = 2 then  send_buf[0]:= SYS_STEP2;
    if Kanal = 3 then  send_buf[0]:= SYS_STEP3;
    if Kanal = 4 then  send_buf[0]:= SYS_STEP4;

    send_buf[1]:= 2;                      // dreh

    send_buf[2]:= abcschritte mod $100;   // Schrittzahl low
    send_buf[3]:= abcschritte div $100;   // Schrittzahl high

    links         :=  1;
    vollschritt   :=  2;
    synchron      :=  4;
    poweroff      :=  8;
    wave          := 16;
    beschleunigen := 32;
    mal10         := 64;
    if abcrichtRadioGroup.itemindex<>0  then links         := 0;
    if abcModeRadioGroup.itemindex<>1   then vollschritt   := 0;
    if abcasyncCheckBox.checked         then synchron      := 0;
    if not abcCheckBox.checked          then poweroff      := 0;
    if abcModeRadioGroup.itemindex<>2   then wave          := 0;
    if not abcBbCheckBox.checked        then beschleunigen := 0;
    if not abcX10CheckBox.checked       then mal10         := 0;
    send_buf[4]:= links + vollschritt + synchron +poweroff + wave + beschleunigen + mal10;

    send_buf[5]:=1;
    case abcTaktRadioGroup.itemindex of
      0: send_buf[5]:=1;              //1000 Hz
      1: send_buf[5]:=2;              //500 Hz
      2: send_buf[5]:=3;              //333 Hz
      3: send_buf[5]:=4;              //250 Hz
      4: send_buf[5]:=5;              //200 Hz
      5: send_buf[5]:=10;             //100 Hz
      6: send_buf[5]:=20;             //50 Hz
      7: send_buf[5]:=100;            //10 Hz
      8: send_buf[5]:=250;            //4 Hz
    end;
    Sende_Empfange(16, 16);
end;


procedure TForm1.abcTrackBarChange(Sender: TObject);
begin
  abcschritte:= sqr(abcTrackBar.position);
  abcLabel.caption:=inttostr(abcschritte)+' Steps';
end;


procedure TForm1.Button98Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=3;                 // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           // high
    wert:=wert*256+ receive_buf[2]; // low
    memo1.lines.add('Steps1: '+inttostr(wert));
end;

procedure TForm1.Button99Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP3;
    send_buf[1]:=1;           // on
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button100Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP4;
    send_buf[1]:=1;           // on
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button101Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP3;
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button102Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP4;
    send_buf[1]:=0;           // off
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button103Click(Sender: TObject);
begin
  runsteps(3);
end;

procedure TForm1.Button104Click(Sender: TObject);
begin
  runsteps(4);
end;

procedure TForm1.Button105Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_STEP3;
    send_buf[1]:=3;                 // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           // high
    wert:=wert*256+ receive_buf[2]; // low
    memo1.lines.add('Steps3: '+inttostr(wert));
end;

procedure TForm1.Button106Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_STEP4;
    send_buf[1]:=3;                 // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           // high
    wert:=wert*256+ receive_buf[2]; // low
    memo1.lines.add('Steps4: '+inttostr(wert));
end;

procedure TForm1.Button107Click(Sender: TObject);
begin
    send_buf[0]:=SYS_STEP1;
    send_buf[1]:=4;           // on
    send_buf[2]:=2;           //schreiben
    send_buf[3] := 10;
    send_buf[4] := 8;
    send_buf[5] := 7;
    send_buf[6] := 6;
    send_buf[7] := 5;
    send_buf[8] := 4;
    send_buf[9] := 3;
    send_buf[10]:= 2;
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button108Click(Sender: TObject);
var e,z,h,t : byte;
    maske : word;
begin
    send_buf[0]:= SYS_SR;       // Schieberegister
    send_buf[1]:= 2;            // senden
    send_buf[2]:= 2;            // 2 bytes
    maske := SRTrackBar.position * 200;  // 0 .. 10000
    e := maske mod 10;
    maske := maske div 10;
    z := maske mod 10;
    maske := maske div 10;
    h := maske mod 10;
    maske := maske div 10;
    t := maske mod 10;
    maske := maske div 10;
    send_buf[3]:= t*16+h;
    send_buf[4]:= z*16+e;
    memo1.lines.add('SR-out: '+inttohex(send_buf[1],2)+'  '+inttohex(send_buf[2],2)+': '+inttohex(send_buf[3],2)+'  '+inttohex(send_buf[4],2)+' =  '+inttostr(maske)+' Hz');
    Sende_Empfange(16, 16);
    memo1.lines.add('SR-in:  '+inttohex(receive_buf[1],2)+'  '+inttohex(receive_buf[2],2)+': '+inttohex(receive_buf[3],2)+'  '+inttohex(receive_buf[4],2));

    //load-pin auf high
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=6;         // write
    send_buf[2]:=$00;       // PORTA
    send_buf[3]:=$04;       // PORTB
    send_buf[4]:=$00;       // PORTC
    Sende_Empfange(16, 16);
    sleep(1);

    //load-pin auf low
    send_buf[0]:=SYS_IO;    // IO
    send_buf[1]:=7;         // write
    send_buf[2]:=$00;       // PORTA
    send_buf[3]:=$04;       // PORTB
    send_buf[4]:=$00;       // PORTC
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button109Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_3;   // Counter
    send_buf[1]:=0;             // off
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button110Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_3;   // Counter
    send_buf[1]:=1;             // init
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button111Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_COUNTER_3;   // Counter
    send_buf[1]:=2;             // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           // high
    wert:=wert*256+ receive_buf[2]; // low
    memo1.lines.add('Counter 3: '+inttostr(wert));
end;

procedure TForm1.Button112Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_3;   // Counter
    send_buf[1]:=3;             // write
    send_buf[2]:=10;            // low
    send_buf[3]:=0;             // high
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button113Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_3;   // Counter
    send_buf[1]:=4;             // erase
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button114Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_0;   // Counter
    send_buf[1]:=0;             // off
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button115Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_0;   // Counter
    send_buf[1]:=1;             // init
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button116Click(Sender: TObject);
var wert : integer;
begin
    send_buf[0]:=SYS_COUNTER_0;   // Counter
    send_buf[1]:=2;             // read
    Sende_Empfange(16, 16);
    wert:=receive_buf[3];           // high
    wert:=wert*256+ receive_buf[2]; // low
    memo1.lines.add('Counter_0: '+inttostr(wert));
end;

procedure TForm1.Button117Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_0;   // Counter
    send_buf[1]:=3;             // write
    send_buf[2]:=10;            // low
    send_buf[3]:=0;             // high
    Sende_Empfange(16, 16);
end;

procedure TForm1.Button118Click(Sender: TObject);
begin
    send_buf[0]:=SYS_COUNTER_0;   // Counter
    send_buf[1]:=4;             // erase
    Sende_Empfange(16, 16);
end;

                   
end.
